/**
Action Script library. Key class definition
Copyright (C) 2005

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#ifndef _AS_KEY_HH
#define _AS_KEY_HH
#include "as_object.hh"

class ASKey : public ASObject{
public:
	ASKey(Script *s, Graphics *g);
	~ASKey();
	Function *getFunctionMember(wstring memberName);
	void 	callFunction(Function *f);
	void	init();
	ASInterface*getNewInstance(Script *s,Graphics *g) { return new ASKey(s,g); }
	ValueObject*getMember(wstring memberName);

	void	addListener();
	void	getAscii();
	void	getCode();
	void	isDown();
	void	isToggled();
	void	removeListener();

	// Events
	void	onKeyDown();
	void	onKeyUp();
};
#endif
