/**
Action Script library. LoadVars class implementation
Copyright (C) 2005 

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#include "as_load_vars.hh"

typedef void (ASLoadVars::*funcPtr)();
static funcPtr callbacks[]= { 
	&ASLoadVars::init,				// 0
	&ASLoadVars::addRequestHeader,	// 1
	&ASLoadVars::getBytesLoaded,	// 2
	&ASLoadVars::getBytesTotal,		// 3
	&ASLoadVars::load,				// 4
	&ASLoadVars::send,				// 5
	&ASLoadVars::sendAndLoad,		// 6
	// Need to be at the end.
	&ASLoadVars::addProperty,		
	&ASLoadVars::registerClass,	
	&ASLoadVars::AStoString,		
	&ASLoadVars::unwatch,			
	&ASLoadVars::valueOf,			
	&ASLoadVars::watch			
};

/**
 * The constructor
 **/
ASLoadVars::ASLoadVars(Script *s, Graphics *g) : ASObject(s,g,L"LoadVars") {
}

/**
 * The destructor
 **/
ASLoadVars::~ASLoadVars() {
}

/**
 * Return a function descriptor
 */
Function *ASLoadVars::getFunctionMember(wstring memberName) {
	Function *func = getBaseFunction(memberName);
	if (memberName == L"LoadVars") 			{func->setFunctionIndex(0); func->setNumParams(0); }
	if (memberName == L"addRequestHeader") 	{func->setFunctionIndex(1); func->setNumParams(10); } // illimited
	if (memberName == L"getBytesLoaded") 	{func->setFunctionIndex(2); func->setNumParams(0); }
	if (memberName == L"getBytesTotal")	 	{func->setFunctionIndex(3); func->setNumParams(0); }
	if (memberName == L"load") 				{func->setFunctionIndex(4); func->setNumParams(1); }
	if (memberName == L"send") 				{func->setFunctionIndex(5); func->setNumParams(3); }
	if (memberName == L"sendAndLoad") 		{func->setFunctionIndex(6); func->setNumParams(3); }
	finishFunctionSetup(memberName,7,func);
	return func;
}

/**
 * Call class built in functions
 **/
void ASLoadVars::callFunction(Function *func) {
	numPassedParams = func->getNumPassedParams();
	(this->*callbacks[func->getFunctionIndex()])();
}

/**
 *
 **/
void ASLoadVars::init() {
	puts("TODO - ASLoadVars::init()");
}

/**
 * Adds or changes HTTP headers for POST operations.
 **/
void ASLoadVars::addRequestHeader() {
	puts("TODO - ASLoadVars::addRequestHeader()");
	noReturnValue();
}

/**
 * Returns the number of bytes downloaded by LoadVars.load() or LoadVars.sendAndLoad().
 **/
void ASLoadVars::getBytesLoaded() {
	puts("TODO - ASLoadVars::getBytesLoaded()");
	noReturnValue();
}

/**
 * Returns the total number of bytes that will be downloaded by a load or sendAndLoad method.
 **/
void ASLoadVars::getBytesTotal() {
	puts("TODO - ASLoadVars::getBytesTotal()");
	noReturnValue();
}

/**
 * Downloads variables from a specified URL.
 **/
void ASLoadVars::load() {
	puts("TODO - ASLoadVars::load()");
	noReturnValue();
}

/**
 * Posts variables from a LoadVars object to a URL.
 **/
void ASLoadVars::send() {
	puts("TODO - ASLoadVars::send()");
	noReturnValue();
}

/**
 * Posts variables from a LoadVars object to a URL and downloads the server’s response to a target object.
 **/
void ASLoadVars::sendAndLoad() {
	puts("TODO - ASLoadVars::sendAndLoad()");
	noReturnValue();
}

/**
 * Returns a URL-encoded string that contains all the enumerable variables in the LoadVars object.
 **/
void ASLoadVars::AStoString() {
	puts("TODO - ASLoadVars::AStoString()");
	noReturnValue();
}
