/**
Action Script library. MovieClipeLoader class implementation
Copyright (C) 2005 

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#include "as_movie_clip_loader.hh"

typedef void (ASMovieClipLoader::*funcPtr)();
static funcPtr callbacks[]= { 
	&ASMovieClipLoader::init,			// 0
	&ASMovieClipLoader::addListener,	// 1
	&ASMovieClipLoader::getProgress,	// 2
	&ASMovieClipLoader::loadClip,		// 3
	&ASMovieClipLoader::removeListener,	// 4
	&ASMovieClipLoader::unloadClip,		// 5
	&ASMovieClipLoader::onLoadComplete,	// 6
	&ASMovieClipLoader::onLoadError,	// 7
	&ASMovieClipLoader::onLoadInit,		// 8
	&ASMovieClipLoader::onLoadProgress,	// 9
	&ASMovieClipLoader::onLoadStart,	// 10
	// Need to be at the end.
	&ASMovieClipLoader::addProperty,		
	&ASMovieClipLoader::registerClass,	
	&ASMovieClipLoader::AStoString,		
	&ASMovieClipLoader::unwatch,			
	&ASMovieClipLoader::valueOf,			
	&ASMovieClipLoader::watch
};

/**
 * The constructor
 **/
ASMovieClipLoader::ASMovieClipLoader(Script *s, Graphics *g) : ASObject(s,g,L"MovieClipLoader") {
}

/**
 * The destructor
 **/
ASMovieClipLoader::~ASMovieClipLoader() {
}

/**
 * Return a function descriptor
 */
Function *ASMovieClipLoader::getFunctionMember(wstring memberName) {
	Function *func = getBaseFunction(memberName);
	if (memberName == L"MovieClipLoader"){func->setFunctionIndex(0); func->setNumParams(0); }
	if (memberName == L"addListener") 	{func->setFunctionIndex(1); func->setNumParams(1); }
	if (memberName == L"getProgress") 	{func->setFunctionIndex(2); func->setNumParams(1); } 
	if (memberName == L"loadClip") 		{func->setFunctionIndex(3); func->setNumParams(2); }
	if (memberName == L"removeListener"){func->setFunctionIndex(4); func->setNumParams(0); }
	if (memberName == L"unloadClip") 	{func->setFunctionIndex(5); func->setNumParams(0); }
	if (memberName == L"onLoadComplete"){func->setFunctionIndex(6); func->setNumParams(0); }
	if (memberName == L"onLoadError") 	{func->setFunctionIndex(7); func->setNumParams(0); } 
	if (memberName == L"onLoadInit") 	{func->setFunctionIndex(8); func->setNumParams(0); } 
	if (memberName == L"onLoadProgress"){func->setFunctionIndex(9); func->setNumParams(0); } 
	if (memberName == L"onLoadStart") 	{func->setFunctionIndex(10); func->setNumParams(0); } 
	finishFunctionSetup(memberName,11,func);
	return func;
}

/**
 * Call class built in functions
 **/
void ASMovieClipLoader::callFunction(Function *func) {
	numPassedParams = func->getNumPassedParams();
	(this->*callbacks[func->getFunctionIndex()])();
}

/**
 *
 **/
void ASMovieClipLoader::init() {
	puts("TODO - ASMovieClipLoader::init()");
}

/**
 * Registers an object to receive notification when a MovieClipLoader event handler is invoked.
 **/
void ASMovieClipLoader::addListener() {
	puts("TODO - ASMovieClipLoader::addListener()");
	noReturnValue();
}

/**
 * Returns the number of bytes loaded and total number of bytes for a file that is being loaded using MovieClipLoader.loadClip().
 **/
void ASMovieClipLoader::getProgress() {
	puts("TODO - ASMovieClipLoader::getProgress()");
	noReturnValue();
}

/**
 * Loads a SWF or JPEG file into a movie clip in Flash Player while the original movie is playing.
 **/
void ASMovieClipLoader::loadClip() {
	puts("TODO - ASMovieClipLoader::loadClip()");
	noReturnValue();
}

/**
 * Deletes an object that was registered using MovieClipLoader.addListener().
 **/
void ASMovieClipLoader::removeListener() {
	puts("TODO - ASMovieClipLoader::removeListener()");
	noReturnValue();
}

/**
 * Removes a movie clip that was loaded by means of MovieClipLoader.loadClip().
 **/
void ASMovieClipLoader::unloadClip() {
	puts("TODO - ASMovieClipLoader::unloadClip()");
	noReturnValue();
}

/**
 * Invoked when a file loaded with MovieClipLoader.loadClip() has completely downloaded.
 **/
void ASMovieClipLoader::onLoadComplete() {
	puts("TODO - ASMovieClipLoader::onLoadComplete()");
	noReturnValue();
}

/**
 * Invoked when a file loaded with MovieClipLoader.loadClip() has failed to load.
 **/
void ASMovieClipLoader::onLoadError() {
	puts("TODO - ASMovieClipLoader::onLoadError()");
	noReturnValue();
}

/**
 * Invoked when the actions on the first frame of the loaded clip have been executed.
 **/
void ASMovieClipLoader::onLoadInit() {
	puts("TODO - ASMovieClipLoader::onLoadInit()");
	noReturnValue();
}

/**
 * Invoked every time the loading content is written to disk during the loading process.
 **/
void ASMovieClipLoader::onLoadProgress() {
	puts("TODO - ASMovieClipLoader::onLoadProgress");
	noReturnValue();
}

/**
 * Invoked when a call to MovieClipLoader.loadClip() has successfully begun to download a file.
 **/
void ASMovieClipLoader::onLoadStart() {
	puts("TODO - ASMovieClipLoader::onLoadStart");
	noReturnValue();
}

