/**
Action Script library. MovieClipeLoader class definition
Copyright (C) 2005

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#ifndef _AS_MOVIE_CLIP_LOADER_HH
#define _AS_MOVIE_CLIP_LOADER_HH
#include "as_object.hh"

class ASMovieClipLoader : public ASObject{
public:
	ASMovieClipLoader(Script *s, Graphics *g);
	~ASMovieClipLoader();
	Function *getFunctionMember(wstring memberName);
	void 	callFunction(Function *f);
	void 	init();
	ASInterface*getNewInstance(Script *s,Graphics *g) { return new ASMovieClipLoader(s,g); }

	void	addListener();
	void	getProgress();
	void	loadClip();
	void	removeListener();
	void	unloadClip();
	void	onLoadComplete();
	void	onLoadError();
	void	onLoadInit();
	void	onLoadProgress();
	void	onLoadStart();
};
#endif
