/**
Action Script library. Stage class implementation
Copyright (C) 2005

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#include "as_stage.hh"

typedef void (ASStage::*funcPtr)();
static funcPtr callbacks[]= { 
	&ASStage::init,			// 0
	&ASStage::addListener,	// 1
	&ASStage::addListener,	// 2
	&ASStage::onResize,		// 3
	// Need to be at the end.
	&ASStage::addProperty,		
	&ASStage::registerClass,	
	&ASStage::AStoString,		
	&ASStage::unwatch,			
	&ASStage::valueOf,			
	&ASStage::watch
};

/**
 * The constructor
 **/
ASStage::ASStage(Script *s, Graphics *g) : ASObject(s,g,L"Stage") {
	setMemberNoClone(L"scaleMode",new StringObject(L"showAll")); 
	setMemberNoClone(L"showMenu",new StringObject(L"true")); 
}

/**
 * The destructor
 **/
ASStage::~ASStage() {
}

/**
 * Return a function descriptor
 */
Function *ASStage::getFunctionMember(wstring memberName) {
	Function *func = getBaseFunction(memberName);
	if (memberName == L"Stage") 		{func->setFunctionIndex(0); func->setNumParams(0); }
	if (memberName == L"addListener") 	{func->setFunctionIndex(1); func->setNumParams(1); }
	if (memberName == L"addListener") 	{func->setFunctionIndex(2); func->setNumParams(1); }
	if (memberName == L"onResize")	 	{func->setFunctionIndex(3); func->setNumParams(1); }
	func = finishFunctionSetup(memberName,4,func);
	return func;
}

/**
 * Call class built in functions
 **/
void ASStage::callFunction(Function *func) {
	numPassedParams = func->getNumPassedParams();
	(this->*callbacks[func->getFunctionIndex()])();
}

/**
 *
 **/
void ASStage::init() {
	puts("TODO - ASStage::init()");
}

/**
 * Adds a listener object that detects when a SWF file is resized.
 **/
void ASStage::addListener() {
	puts("TODO - ASStage::addListener()");
	noReturnValue();
}

/**
 *  Removes a listener object from the Stage object.
 **/
void ASStage::removeListener() {
	puts("TODO - ASStage::removeListener()");
	noReturnValue();
}

void ASStage::onResize() { puts("TODO - ASStage::onResize()") ; }

