/**
Macromedia Flash File graphic lib ( triangulation for OpenGL).
Copyright (C) 2005  Christophe Choquet (cchoquet@users.sourceforge.net)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#ifndef _OGL_GRAPHICS_HH_
#define _OGL_GRAPHICS_HH_
#include "bgraphics.hh"

typedef struct {
	double	x,y;
	int 	colorIndex;	
	bool	transparent;
} RegionProperty;

class OglGraphics : public Graphics {
public:
	OglGraphics(BaseTexture *texture, LocalFontManager *localFontManager);

private:
	void	getRegions(list<RegionProperty> *regions);
	DrawingSequence *shape2Triangles();
	void	getIntersectionPoints(list<float> *resY,list<RegionProperty> *regions, int currentSegmentId);
};

#endif
