/**
Macromedia Flash OpenGl renderer definition.
Copyright (C) 2005  Christophe Choquet (cchoquet@users.sourceforge.net)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#ifndef _OGL_RENDERER_
#define _OGL_RENDERER_
#include "common.hh"
#include "swf.hh"
#define GL_GLEXT_PROTOTYPES
#include <GL/glx.h>
#include <GL/glu.h>
#include <GL/glext.h>
#include "bgraphics.hh"
#include <stack>
#include "brenderer.hh"

class OglRenderer : public BaseRenderer {
public:
	OglRenderer(BaseTexture *texture);
	~OglRenderer();

	void 	clearWindow();
	void 	flush();
	void	renderCharacter(ListDrawingSequence *dr,int clipDepth);
	void	applyMatrix(MATRIX *m);
	void	initCharacter();
	void	resetClipDepth() { glDisable(GL_STENCIL_TEST);}
	void 	pushMatrix() { glPushMatrix(); }
	void 	popMatrix() { glPopMatrix(); }
	void    getTransformMatrix(float *m) { glGetFloatv(GL_MODELVIEW_MATRIX,m); }
	bool	displayCaret(Caret c);

private:
	bool	hasVertexArrayCompile;
	bool	hasGL_ARB_multisample,hasGL_ARB_fragment_shader;
	GLuint	vp1D, vp2D;
	int		lastTextureId;
	int		lastPixelShader;
	bool	pixelShadersLoaded;

	void 	doRenderCharacterNoCompile(DrawingSequence *d, bool isSecondPass);
	void	detectCapababilities();
	bool	checkExtension(char *p,char *extName );
	void	setupTexture(DrawingSequence *d,DrawingEntry *d);
	string 	buildPixelShaderProgram(char *dim);
	void	loadPixelShaders();
};
#endif
