/**
Macromedia Flash OpenGl texture definition.
Copyright (C) 2005  Christophe Choquet (cchoquet@users.sourceforge.net)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#ifndef _OGL_TEXTURE_
#define _OGL_TEXTURE_
#include <GL/glx.h>
#include <GL/glu.h>
#include "btexture.hh"

class OglTexture : public BaseTexture {
public:
	OglTexture();
	unsigned int allocateTexture(int textureWidth, int textureHeight);
	unsigned int allocateTexture24(int textureWidth, int textureHeight);
	int	 registerColor(RGBA *c);
	void video2Texture(int textureId, int dimx, int dimy, char *data);
	void removeTexture(unsigned int textureId);
	unsigned int getColorTexture() { return glColorTexture; }
	int	 getMaxTextureSize();
	void storeAlphaBitmap(unsigned int glTextureID, int xOffset, int yOffset, int destWidth, int destHeight, unsigned char* buffer);
private:
	unsigned int store1DTextureRepeatLinear(int generatedTexSize, RGBA *textureMemory);
	unsigned int store2DTextureRepeatLinear( int width, int height, RGBA *textureMemory);
	unsigned int glColorTexture;
	bool	useConcervativeTexture;
};

#endif
