/**
Macromedia Flash File Uncompress lib.
Copyright (C) 2004  Christophe Choquet (cchoquet@users.sourceforge.net)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#ifndef _UNCOMPRESS_H_
#define _UNCOMPRESS_H_
#include "common.hh"
#include "swf.hh"
#include <setjmp.h>
extern "C" {
#include "jpeglib.h"
}
#include "zlib.h"

struct MyErrorHandler {
	struct jpeg_error_mgr pub;
	jmp_buf setjmp_buffer;
};

class UncompressTools {
public:
	bool uncompressJPEGData(UI8 *stream,Image *img,bool read_alpha, long offset);
	bool buildFromZlibData(UI8 *buffer,Image *img, int width, int height, int format, int tableSize, int tableHasAlpha);
	bool buildFromJpegAbbreviatedData(UI8* dataStream,UI8* tableStream,Image *img);
private:
	bool buildJpegAlpha(Image *img, UI8 *buffer);
	bool readJpegTables(UI8 *stream, struct jpeg_decompress_struct &jpegObject,MyErrorHandler &jpegErrorMgr,struct jpeg_source_mgr &jpegSourceManager);
};
#endif
