/**
Plugin interface. Konqueror.
Copyright (C) 2005  Christophe Choquet (cchoquet@users.sourceforge.net)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#include <kdebug.h>
#include "kflash_plugin.hh"
#include <kinstance.h>
#include <klocale.h>
#include <kaboutdata.h>
#include <qwidget.h>
#include <qlayout.h>


extern "C" {
	void *init_libkxglpart() {
		return new KflashPartFactory;
	}
};

KInstance *KflashPartFactory::s_instance = NULL;
KAboutData *KflashPartFactory::s_about = NULL;

KflashPartFactory::KflashPartFactory() {
}

KflashPartFactory::~KflashPartFactory(){
	if(s_instance) delete s_instance;
	if(s_about) delete s_about;
	s_instance = NULL;
	s_about = NULL;
}

KParts::Part *KflashPartFactory::createPartObject(QWidget *parentwidget, const char *widgetname, QObject *parent, const char *name, const char *classname, const QStringList& args) {
	return new KflashPlugin(parentwidget, name);
}

KInstance *KflashPartFactory::instance() {
	if(!s_instance)	{
		s_about = new KAboutData("kxgl", I18N_NOOP("KXGL Viewer Part"), "0.1", "KDE XGL 3D model viewer", KAboutData::License_GPL);
		s_about->addAuthor("Josef Spillner", "Programming", "dr_maux@users.sourceforge.net");
		s_instance = new KInstance(s_about);
	}
	return s_instance;
}


KflashPlugin::KflashPlugin( QObject* parent, const char* name ) : ReadOnlyPart( parent, name ) {
	setInstance(KflashPlugin::instance());

//	viewer = new Viewer(parent);
//	viewer->setFocusPolicy(QWidget::ClickFocus);
//	setWidget(viewer);

	m_extension = new KflashPartBrowserExtension(this);
}

KflashPlugin::~KflashPlugin() {
	//closeURL();
}

bool KflashPlugin::openFile() {
//	viewer->load(m_file);
	return true;
}


KflashPartBrowserExtension::KflashPartBrowserExtension(KflashPlugin *parent)
: KParts::BrowserExtension(parent, "KflashPartBrowserExtension")
{
}

KflashPartBrowserExtension::~KflashPartBrowserExtension()
{
}
